using System;

namespace CSharpApplication.ConvertDecimalFractionToSimpleFraction
{
	class Fraction
	{
		static void Main()
		{
			//  
			Console.Write(" : ");
			
			try
			{
				//      decimal
				DecimalToSimpleFraction(Convert.ToDecimal(Console.ReadLine()));
			}
			catch(FormatException error)
			{
				//    
				Console.WriteLine(error.Message);
			}

			Console.WriteLine(" Enter...");
			Console.Read();
		}
		
		//  
		static void DecimalToSimpleFraction(decimal Number)
		{
			//   
			int Sign = 1;
			if(Number < 0) 
			{
				Sign = -1;
				Number = -Number;
			}
			//    
			int WholePart = (int)Number;
			//    
			decimal DoublePart = Number - WholePart;

			//  
			int Count = 0;
			
			//         
			while (DoublePart - (ulong)DoublePart != 0) 
			{
				//  
				DoublePart *= 10;
				++Count;
			}

			//    
			if(Count > 0)
			{
				//  
				decimal Denominator = Convert.ToDecimal(Math.Pow(10, Count));
				//    
				decimal N = NOD(DoublePart, Denominator);

				//  
				DoublePart /= N;
				Denominator /= N;

				//  
				if(WholePart != 0)
					Console.WriteLine("{0}  {1} / {2}", WholePart * Sign, DoublePart, Denominator);
				else
					Console.WriteLine("{0} / {1}", DoublePart * Sign, Denominator);
			}
			//    
			else
				Console.WriteLine("{0}", WholePart * Sign);
		}

		// ,    
		static decimal NOD(decimal a, decimal b)
		{
			if(b == 0)
				return a;
			else
				return NOD(b, a % b);
		}
	}
}