using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
//   ArrayList
using System.Collections;
//    
using Microsoft.Win32;
using System.Diagnostics;

// ,   

namespace CSharpApplication.ScreenSaverExample
{
    class ScreenSaver : Form
    {
        //      
        Point StartCursorPosition = Control.MousePosition;
        //    
        Timer tm = new Timer();
        // 
        Image im = null;
        //    
        ArrayList PathList;
        //   
        RectangleF ScreenRect;
        //  ,   
        //      
        Graphics gr = null;

        //    
        //    
        static System.Threading.Mutex mutex;

        //     
        static string Path;

        //    
        //  Windows
        static IntPtr handle = IntPtr.Zero;

        static void Main(string [] args /*    */)
        {           
            //     HKEY_CURRENT_USER
            RegistryKey rk = Registry.CurrentUser;
            //     
            rk = rk.CreateSubKey(@"Software\CSharpApplications\ScreenSaver");
            //      null  
            Path = (string)rk.GetValue("PathToImages", null);
            //  
            rk.Close();

            //           
            if(args.Length > 0)
            {
                //   
                if(args[0].StartsWith("/c"))
                {
                    //     
                    Settings set = new Settings(Path);
                    set.ShowDialog();
                    return;
                }
                //   
                if(args[0].StartsWith("/p"))
                {
                    //  
                    mutex = new System.Threading.Mutex(false, "ScreenSaver.MyMutex");
                    //        
                    if(mutex.WaitOne(0, false) == false)
                    {
                        //  
                        return;
                    }
                    //   ,  
                    // Windows  
                    //  
                    handle = (IntPtr)Convert.ToInt32(args[1]);
                }
            }

            //  
            Application.Run(new ScreenSaver());

            //  
            if(mutex != null)
                mutex.ReleaseMutex();
        }

        // 
        ScreenSaver()
        {
            //   
            this.BackColor = Color.Black;
            //    
            this.FormBorderStyle = FormBorderStyle.None;
            
            //  
            Cursor.Hide();

            //     
            this.ClientSize = Screen.GetBounds(this).Size;
            //   
            this.Location = new Point(0, 0);
            
            //  
            if(handle != IntPtr.Zero)
            {
                //     
                this.ShowInTaskbar = false;
                //   
                this.TransparencyKey = Color.Black;
            }
         
            //  
            tm.Tick += new EventHandler(tm_Tick);
            tm.Interval = 1000;
        }

        //   
        protected override void OnKeyDown(KeyEventArgs e)
        {
            //  
            Application.Exit();
            base.OnKeyDown (e);
        }

        //   
        protected override void OnMouseMove(MouseEventArgs e)
        {
            //       
            if(StartCursorPosition != Control.MousePosition)
            {
                //  
                Application.Exit();
            }

            base.OnMouseMove (e);
        }

        //    
        protected override void OnPaint(PaintEventArgs e)
        {   
            if(handle == IntPtr.Zero)
            {
                //   
                gr = e.Graphics;            
            }
            else
            {
                try
                {
                    //   
                    //     Windows
                    gr = Graphics.FromHwnd(handle);
                }
                catch
                {
                    //  
                    Application.Exit();
                    return;
                }
            }

            //    
            ScreenRect = gr.VisibleClipBounds;

            //  
            if(handle !=IntPtr.Zero)
            {
                //   
                Brush br = new SolidBrush(Color.Black);
                //   
                // (  )
                gr.FillRectangle(br, ScreenRect);
            }
            //    
            if(PathList != null && PathList.Count == 0)
            {
                //   
                Brush br = new SolidBrush(Color.Blue);
                //  
                Font font = new Font("Times New Roman", 12);
                //  
                gr.DrawString("\n" + Path + "\n!!!", font, br, 0, 0);
            }
            else if(PathList != null)
            {
                //   
                //      
                SizeF sizef = new SizeF(im.Width / im.HorizontalResolution,
                                        im.Height / im.VerticalResolution);
                float Scale = Math.Min(ScreenRect.Width / sizef.Width,
                                       ScreenRect.Height / sizef.Height);
                //    
                sizef.Width *= Scale;
                sizef.Height *= Scale;

                //  
                gr.DrawImage(im, 
                   ScreenRect.X + (ScreenRect.Width - sizef.Width) / 2,
                   ScreenRect.Y + (ScreenRect.Height - sizef.Height) / 2,
                   sizef.Width, sizef.Height);
                 
                tm.Interval = 3000;
            }            

            base.OnPaint (e); 

            //  
            tm.Start();
        }

        //  
        private void tm_Tick(object sender, EventArgs e)
        {          
            //  
            tm.Stop();

            //   ,    
            if(handle != IntPtr.Zero)
            {
                string temppath;
                RegistryKey rk = Registry.CurrentUser;
                rk = rk.CreateSubKey(@"Software\CSharpApplications\ScreenSaver");
                temppath = (string)rk.GetValue("PathToImages", null);
                rk.Close();

                //   
                if(Path != temppath)
                {
                    Path = temppath;
                    PathList = null;
                }
            }
    
            //      
            //  
            if(PathList == null)
                SearchPictures();

            //  
            string picture = null;         
            
            //   
            if(PathList != null)
            {
                //     
                if(PathList.Count == 0)
                {
                    //  (    )
                    Invalidate();
                    return;
                }

                //    
                Random rand = new Random();
                //     
                picture = (string)PathList[rand.Next(PathList.Count)];
            }
            else  //    
            {
                //    Windows
                //   
                Path = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures);
                tm.Interval = 100;
                //  
                tm.Start();
                return;
            }

            try
            {
                //    
                im = Image.FromFile(picture);
            }
            catch
            {
                // 
                im = null;
                tm.Interval = 100;
                //   (  )
                tm.Start();
                return;
            }

            // 
            Invalidate();
        }

        //   
        void SearchPictures()
        {
            try
            {
                //    
                string [] files1 = Directory.GetFiles(Path, "*.jpg"); 
                string [] files2 = Directory.GetFiles(Path, "*.bmp"); 
                
                //     
                //      
                PathList = new ArrayList(files1.Length + files2.Length);
                PathList.AddRange(files1);
                PathList.AddRange(files2);
            }
            catch
            {
                // 
                PathList = null;
            }
        }
    }

    //  
    class Settings : Form
    {
        Button Browse = new Button();
        TextBox PathToImages = new TextBox();
        Label Prompt = new Label();

        FolderBrowserDialog fbd = new FolderBrowserDialog();

        public Settings(string Path /*     */)
        {
            this.ClientSize = new Size(260, 90);
            this.MaximizeBox = false;
            this.MinimizeBox = false;

            Browse.Parent = this;
            Browse.Dock = DockStyle.Top;           
            Browse.Text = " ";

            Browse.Click += new EventHandler(Browse_Click);

            PathToImages.Parent = this;
            PathToImages.Dock = DockStyle.Top;
            PathToImages.ReadOnly = true; 
            PathToImages.Size = new Size(0, 50);
            PathToImages.Multiline = true;
            PathToImages.Text = Path;

            Prompt.Parent = this;
            Prompt.Dock = DockStyle.Top;
            Prompt.AutoSize = true;
            Prompt.Text = "     :";

            fbd.SelectedPath = Path;

            this.Text = "";
            this.ShowInTaskbar = false;
            this.CenterToScreen();
        }

        //   
        private void Browse_Click(object sender, EventArgs e)
        {
            //    OK
            if(fbd.ShowDialog() == DialogResult.OK)
            {
                //     
                RegistryKey rk = Registry.CurrentUser;
                rk = rk.CreateSubKey(@"Software\CSharpApplications\ScreenSaver");
                //    
                rk.SetValue("PathToImages", fbd.SelectedPath);
                rk.Close();
                //      
                PathToImages.Text = fbd.SelectedPath;
            }
        }
    }
}