using System;
using System.Drawing;
using System.Windows.Forms;
using System.Data;
using System.Data.Odbc;

namespace CSharpApplication.ODBC
{
    class ODBCExample : Form
    {
        //  
        DataSet dataset = new DataSet("Library");
        //   ""
        DataGrid datagrid = new DataGrid();
        //      
        OdbcConnection connection = new OdbcConnection();
        //       
        OdbcCommand command = new OdbcCommand();
        //         
        OdbcDataAdapter adapter = new OdbcDataAdapter();
        
        //  
        TextBox Query = new TextBox();
        //  
        Button Execute = new Button();

        static void Main()
        {
            Application.Run(new ODBCExample());
        }

        ODBCExample()
        {
            this.WindowState = FormWindowState.Maximized;
            this.Text = "ODBC Example";
            this.Icon = new Icon(GetType(), "books.ico");

            //     
            string con = @"Driver={Microsoft Access Driver (*.mdb)};DBQ=books.mdb";
            connection.ConnectionString = con;
            //  
            connection.Open();

            //       
            command.Connection = connection;
            //   
            command.CommandText = "select * from books";
            
            //    
            adapter.SelectCommand = command;
            //    
            adapter.Fill(dataset);
            
            //   
            dataset.Tables[0].DefaultView.AllowDelete = false;
            //   
            dataset.Tables[0].DefaultView.AllowEdit = false;
            //   
            dataset.Tables[0].DefaultView.AllowNew = false;

            //  
            datagrid.Parent = this;
            //     
            // (       )
            datagrid.DataSource = dataset.Tables[0];
            datagrid.ClientSize = new Size(this.ClientSize.Width, this.ClientSize.Height - 100);
            datagrid.Location = new Point(0, 0);
            datagrid.Anchor = AnchorStyles.Bottom | AnchorStyles.Top |
                AnchorStyles.Left | AnchorStyles.Right;

            Query.Parent = this;
            Query.Dock = DockStyle.Bottom;
            Query.Height = 80;
            Query.Multiline = true;
            Query.ScrollBars = ScrollBars.Vertical;
            Query.Font = new Font("Arial", 12);
            //     
            Query.Select();

            Execute.Parent = this;
            Execute.Dock = DockStyle.Bottom;
            Execute.Height = 20;
            Execute.Text = " ";
            Execute.Click += new EventHandler(Execute_Click);
        }
        
        //   
        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            //     
            connection.Close();
            
            base.OnClosing (e);
        }

        //    
        private void Execute_Click(object sender, EventArgs e)
        {
            ExecuteQuery();
        }

        //   
        private void ExecuteQuery()
        {
            //      
            Query.Text.ToLower();
            //    
            command.CommandText = Query.Text;
            
            //   ?
            if(Query.Text.StartsWith("select"))
            {
                //    
                adapter.SelectCommand = command;
                //    
                dataset.Clear();

                try
                {
                    //    
                    adapter.Fill(dataset);
                    //     
                    datagrid.DataSource = dataset.Tables[0];
                }
                catch(Exception ex)
                {
                    //  
                    // (,  )
                    MessageBox.Show(ex.Message);
                }
            }
            //   
            else
            {
                try
                {
                    //    
                    command.ExecuteNonQuery();
                }
                catch(Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    return;
                }
                //                                                
                dataset.Clear();
                //    
                command.CommandText = "select * from books";
                adapter.SelectCommand = command;

                try
                {
                    //   
                    adapter.Fill(dataset);
                    datagrid.DataSource = dataset.Tables[0];
                }
                catch(Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }
    }
}
