using System;
using System.Drawing;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

namespace CSharpApplication.OleDb
{
    class OleDbExample : Form
    {
        //  
        DataSet dataset = new DataSet("Library");
        // 
        DataGrid datagrid = new DataGrid();
        //       
        // OleDb Provider
        OleDbConnection connection = new OleDbConnection();
        
        static void Main()
        {
            Application.Run(new OleDbExample());
        }

        OleDbExample()
        {
            this.WindowState = FormWindowState.Maximized;
            this.Text = "OleDb Example";

            //    Access'  
            string con = @"Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Library.mdb";
            connection.ConnectionString = con;
            //  
            connection.Open();

            //    ,   
            DataTable Tables = connection.GetOleDbSchemaTable(
                OleDbSchemaGuid.Tables,
                new object[] {null, null, null, "TABLE"});

            //    
            foreach(DataRow row in Tables.Rows)
            {
                //     (3- )
                string Name = (string)row[2];
            
                //      
                DataTable ColumnsInTable = connection.GetOleDbSchemaTable(
                    OleDbSchemaGuid.Columns,
                    new object[] {null, null, Name, null});

                //  "" 
                // (  )
                ColumnsInTable.Columns.RemoveAt(0);
                ColumnsInTable.Columns.RemoveAt(0);
                ColumnsInTable.Columns.RemoveAt(0);
                ColumnsInTable.Columns.RemoveAt(1);
                ColumnsInTable.Columns.RemoveAt(1);
                ColumnsInTable.Columns.RemoveAt(4);
                ColumnsInTable.Columns.RemoveAt(5);
                ColumnsInTable.Columns.RemoveAt(5);
                ColumnsInTable.Columns.RemoveAt(6);
                ColumnsInTable.Columns.RemoveAt(9);
                ColumnsInTable.Columns.RemoveAt(9);
                ColumnsInTable.Columns.RemoveAt(10);
                ColumnsInTable.Columns.RemoveAt(10);
                ColumnsInTable.Columns.RemoveAt(10);
                ColumnsInTable.Columns.RemoveAt(10);
                ColumnsInTable.Columns.RemoveAt(10);
                ColumnsInTable.Columns.RemoveAt(10);
                
                //    
                ColumnsInTable.TableName = Name;

                //     
                dataset.Tables.Add(ColumnsInTable);
            }          

            datagrid.Parent = this;
            //      
            datagrid.DataSource = dataset;
            datagrid.ClientSize = this.ClientSize;
            datagrid.Location = new Point(0, 0);
            datagrid.Anchor = AnchorStyles.Bottom | AnchorStyles.Top |
                AnchorStyles.Left | AnchorStyles.Right;

            //  
            datagrid.CaptionText = "Structure of tables of database \"Library\"";
            //   
            datagrid.CaptionFont = new Font("Verdana", 16);
            //     
            datagrid.LinkColor = Color.Blue;
            //  
            datagrid.Font = new Font("Arial", 10);
            //     
            datagrid.ReadOnly = true;
            
            //   
            datagrid.Expand(-1);
        }

        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            //  
            connection.Close();
            base.OnClosing (e);
        }
    }
}