using System;

namespace CSharpApplication.ArraysExample
{
    class Arrays
    {
        /*******************************************************************/
        /*       " ".
        /*           :)
        /*******************************************************************/
        //  
        static int [,] Transform(int [,] mtr)
        {
            //  
            int M = mtr.GetLength(0);
            //  
            int N = mtr.GetLength(1);

            //  
            int [,] t_ar = new int[N, M];

            // 
            for(int i = 0; i < M; i++)
            {
                for(int j = 0; j < N; j++)
                {
                    t_ar[j,i] = mtr[i,j];
                }
            }

            return t_ar;
        }

        //  
        static void Print(int [,] mtr)
        {
            //  
            int M = mtr.GetLength(0);
            //  
            int N = mtr.GetLength(1);

            for(int i = 0; i < M; i++)
            {
                for(int j = 0; j < N; j++)
                {
                    Console.Write("{0,8}", mtr[i,j]);
                }
                Console.WriteLine();
            }
            Console.WriteLine();
        }

        //    
        static void Init(int [,] mtr)
        {
            //    
            Random rand = new Random();

            //   
            int M = mtr.GetLength(0);
            int N = mtr.GetLength(1);

            for(int i = 0; i < M; i++)
            {
                for(int j = 0; j < N; j++)
                {
                    //    
                    //  0  99999
                    mtr[i,j] = rand.Next(100000);
                }
            }
        }

        static void Main()
        {
            //  
            uint M = 0, N = 0;

            Console.WriteLine("  : ");
            try
            {
                //     
                Console.WriteLine("M: ");
                M = Convert.ToUInt32(Console.ReadLine());
                Console.WriteLine("N: ");
                N = Convert.ToUInt32(Console.ReadLine());
            }
            catch(OverflowException ex)
            {   
                //     ()
                Console.WriteLine(ex.Message + " Use default size (=10x10)");
            }
            catch(FormatException ex)
            {   
                //    
                Console.WriteLine(ex.Message + " Use default size (=10x10)");
            }
            
            //   ,     1010 
            if(M == 0 || N == 0)
                M = N = 10;
            
            //  
            int [,] ar = new int[M, N];

            Console.WriteLine(":");
            // 
            Init(ar);
            // 
            Print(ar);
 
            // 
            int [,] t_ar = Transform(ar);
           
            Console.WriteLine(" :");
            //   
            Print(t_ar);
       }
    }
}