using System;

namespace CSharpApplication.CloneExample
{
    //  
    class Student
    {
        // 
        string FirstName;
        // 
        string LastName;
        // 
        string Address;
        // 
        string Phone;
        //  
        DateTime BirthDay;
        
        //   
        public Student Clone()
        {
            //     (Object)
            //    
            return (Student)MemberwiseClone();
        }
        //  
        public void Input()
        {
            Console.WriteLine("*****   :******");
            Console.Write(": ");
            FirstName = Console.ReadLine();
            Console.Write(": ");
            LastName = Console.ReadLine();
            Console.Write(": ");
            Address = Console.ReadLine();
            Console.Write(": ");
            Phone = Console.ReadLine();
            Console.Write(" : ");
            try
            {
                BirthDay = Convert.ToDateTime(Console.ReadLine());
            }
            catch
            {
                Console.WriteLine(" ,   ");
                BirthDay = DateTime.Now;
            }
            Console.WriteLine("**********************************");
        }
        //  
        public void Print()
        {
            Console.WriteLine("*****   :*****");
            Console.WriteLine(": {0}", FirstName);
            Console.WriteLine(": {0}", LastName);
            Console.WriteLine(": {0}", Address);
            Console.WriteLine(": {0}", Phone);
            Console.WriteLine(" : {0}.{1}.{2}", 
                BirthDay.Day, BirthDay.Month, BirthDay.Year);
            Console.WriteLine("**********************************");
        }
    }
    //  Group
    class Group : ICloneable
    {
        //  
        string GroupName;
        //  
        Student [] st;

        // ,      
        public Group(string gn, int n)
        {
            GroupName = gn;
            //     10 
            if(n <= 0 || n > 10)
                n = 10;
            st = new Student[n];
            //  
            for(int i = 0; i < n; i++)
                st[i] = new Student();
        }

        //   
        public Group(Group gr)
        {
            //    
            st = new Student[gr.st.Length];
            //   
            GroupName = gr.GroupName;
            //   
            for(int i = 0; i < gr.st.Length; i++)
                st[i] = gr.st[i].Clone();
        }

        //  
        public void Input()
        {   
            for(int i = 0; i < st.Length; i++)
            {
                Console.WriteLine("{0}.", i + 1);
                st[i].Input();
            }
        }
        //    
        public void InputAt(int n)
        {
            if(st == null || n >= st.Length || n < 0)
                return;

            st[n].Input();
        }

        //   
        public void Print()
        {
            Console.WriteLine(" {0}:", GroupName);
            
            for(int i = 0; i < st.Length; i++)
            {
                Console.WriteLine("{0}.", i + 1);
                st[i].Print();
            }
        }
        
        //     
        public void PrintAt(int n)
        {
            if(st == null || n >= st.Length || n < 0)
                return;

            st[n].Print();
        }

        //   
        public string GetGroupName()
        {
            return GroupName;
        }

        //   
        public void SetGroupName(string gn)
        {
            GroupName = gn;
        }

        //  
        public new object MemberwiseClone()
        {
            //   Object
            return base.MemberwiseClone();
        }

        // "" ,
        //     IClonable
        public object Clone()
        {
            //   
            Group gr = new Group(GroupName, st.Length);
            //   
            for(int i = 0; i < st.Length; i++)
                gr.st[i] = st[i].Clone();
            //    
            return gr;
        }
    }

    // 
    class Test
    {
        static void Main()
        {
            //     (  )
            Group gr = new Group("-951", 1);
            gr.Input();
            gr.Print();

            /************************************************************/
            /*       
            /*      
            /************************************************************/
            Group grcopy = gr;

            grcopy.SetGroupName("-951");
            //  
            grcopy.InputAt(0);

            //  (  )
            Console.WriteLine(grcopy.GetGroupName());
            grcopy.PrintAt(0);
            Console.WriteLine(gr.GetGroupName());
            gr.PrintAt(0);

            /************************************************************/
            /*  ,   
            /* ,   st     
            /*   
            /************************************************************/
            grcopy = (Group)gr.MemberwiseClone();

            grcopy.SetGroupName("-951");
            //  
            grcopy.InputAt(0);

            //  (    )
            Console.WriteLine(grcopy.GetGroupName());
            grcopy.PrintAt(0);
            Console.WriteLine(gr.GetGroupName());
            gr.PrintAt(0);

            /************************************************************/
            /* "" ,     
            /************************************************************/
            grcopy = (Group)gr.Clone();

            grcopy.SetGroupName("-951");
            //  
            grcopy.InputAt(0);
            // 
            Console.WriteLine(grcopy.GetGroupName());
            grcopy.PrintAt(0);
            Console.WriteLine(gr.GetGroupName());
            gr.PrintAt(0);

            /************************************************************/
            /*   
            /************************************************************/
            Group gg = new Group(grcopy);
            grcopy.SetGroupName("-951");
            //  
            grcopy.InputAt(0);
            // 
            Console.WriteLine(grcopy.GetGroupName());
            grcopy.PrintAt(0);
            Console.WriteLine(gg.GetGroupName());
            gg.PrintAt(0);
        }
    }
}