using System;
using System.IO;
using System.Text;

namespace CSharpApplication.ReadWriteBinaryData
{
    //  
    class Student
    {
        // 
        string firstname;
        // 
        string lastname;
        // 
        string address;
        // 
        string phone;
        //  
        DateTime birthday;
        //  
        int number;

        // 
        public string FirstName
        {
            get
            {
                return firstname;
            }
            set
            {
                firstname = value;
            }
        }
        public string LastName
        {
            get
            {
                return lastname;
            }
            set
            {
                lastname = value;
            }
        }
        public string Address
        {
            get
            {
                return address;
            }
            set
            {
                address = value;
            }
        }
        public string Phone
        {
            get
            {
                return phone;
            }
            set
            {
                phone = value;
            }
        }
        public DateTime BirthDay
        {
            get
            {
                return birthday;
            }
            set
            {
                birthday = value;
            }
        }
        public int Number
        {
            get
            {
                return number;
            }
            set
            {
                number = value;
            }
        }
        
        //   
        public Student Clone()
        {
            //     (Object)
            //    
            return (Student)MemberwiseClone();
        }
        //  
        public void Input()
        {
            Console.WriteLine("*****   :******");
            Console.Write(": ");
            firstname = Console.ReadLine();
            Console.Write(": ");
            lastname = Console.ReadLine();
            Console.Write(": ");
            address = Console.ReadLine();
            Console.Write(": ");
            phone = Console.ReadLine();
            Console.Write(" : ");
            try
            {
                //  
                birthday = Convert.ToDateTime(Console.ReadLine());
            }
            catch
            {
                Console.WriteLine(" ,   ");
                birthday = DateTime.Now;
            }
            Console.Write(" : ");
            try
            {
                number = Convert.ToInt32(Console.ReadLine());
            }
            catch
            {
                Console.WriteLine(" ,   0");
                number = 0;
            }
            Console.WriteLine("**********************************");
        }
        //  
        public void Print()
        {
            Console.WriteLine("*****   :*****");
            Console.WriteLine(": {0}", firstname);
            Console.WriteLine(": {0}", lastname);
            Console.WriteLine(": {0}", address);
            Console.WriteLine(": {0}", phone);
            Console.WriteLine(" : {0}.{1}.{2}", 
                birthday.Day, birthday.Month, birthday.Year);
            Console.WriteLine(" : {0}", number);
            Console.WriteLine("**********************************");
        }

        //   
        public void Write(BinaryWriter bw)
        {
            //     
            bw.Write(firstname);
            bw.Write(lastname);
            bw.Write(address);
            bw.Write(phone);
            bw.Write(birthday.Year);
            bw.Write(birthday.Month);
            bw.Write(birthday.Day);
            bw.Write(number);
        }

        //       
        //       
        public static Student Read(BinaryReader br)
        {
            //    , 
            //  
            Student st = new Student();
            st.firstname = br.ReadString();
            st.lastname = br.ReadString();
            st.address = br.ReadString();
            st.phone = br.ReadString();
            int year = br.ReadInt32();
            int month = br.ReadInt32();
            int day = br.ReadInt32();
            st.birthday = new DateTime(year, month, day);
            st.number = br.ReadInt32();

            return st;
        }
    }
    //  Group
    class Group : ICloneable
    {
        //  
        string groupname;
        //  
        Student [] st;

        // 
        public string GroupName
        {
            get
            {
                return groupname;
            }
            set
            {
                groupname = value;
            }
        }
        public Student [] Students
        {
            get
            {
                return st;
            }
            set
            {
                st = value;
            }
        }

        // ,      
        public Group(string gn, int n)
        {
            groupname = gn;
            //     10 
            if(n < 0 || n > 10)
                n = 10;
            st = new Student[n];
            //  
            for(int i = 0; i < n; i++)
                st[i] = new Student();
        }

        //   
        public Group(Group gr)
        {
            //    
            st = new Student[gr.st.Length];
            //   
            groupname = gr.groupname;
            //   
            for(int i = 0; i < gr.st.Length; i++)
                st[i] = gr.st[i].Clone();
        }

        //  
        public void Input()
        {   
            for(int i = 0; i < st.Length; i++)
            {
                Console.WriteLine("{0}.", i + 1);
                st[i].Input();
            }
        }
        //    
        public void InputAt(int n)
        {
            if(st == null || n >= st.Length || n < 0)
                return;

            st[n].Input();
        }

        //   
        public void Print()
        {
            Console.WriteLine(" {0}:", groupname);
            
            for(int i = 0; i < st.Length; i++)
            {
                Console.WriteLine("{0}.", i + 1);
                st[i].Print();
            }
        }
        
        //     
        public void PrintAt(int n)
        {
            if(st == null || n >= st.Length || n < 0)
                return;

            st[n].Print();
        }

        // "" ,
        //     IClonable
        public object Clone()
        {
            //   
            Group gr = new Group(groupname, st.Length);
            //   
            for(int i = 0; i < st.Length; i++)
                gr.st[i] = st[i].Clone();
            //    
            return gr;
        }

        //   
        public void Write(BinaryWriter bw)
        {
            //   
            bw.Write(groupname);
            //   
            bw.Write(st.Length);
            for(int i = 0; i < st.Length; i++)
                //    
                //     Student
                st[i].Write(bw);
        }

        //       
        //       
        public static Group Read(BinaryReader br)
        {
            string gn = br.ReadString();
            int n = br.ReadInt32();
            
            Student [] st = new Student[n];

            for(int i = 0; i < n; i++)
                //    
                //     Student
                st[i] = Student.Read(br);

            //   
            Group gr = new Group(gn, 0);
            //    
            gr.st = st;

            return gr;
        }
    }

    // 
    class Test
    {
        static void Main()
        {
            // 
            Group gr = new Group("-951", 3);

            gr.Input();
            gr.Print();

            //      /   
            FileStream fs = new FileStream("group.bin", 
                FileMode.OpenOrCreate, FileAccess.Write);
            
            //     
            BinaryWriter bw = new BinaryWriter(fs, Encoding.Default);

            //  
            gr.Write(bw);
            //  
            bw.Close();
            fs.Close();

            //      
            fs = new FileStream("group.bin", FileMode.Open, FileAccess.Read);
            //     
            BinaryReader br = new BinaryReader(fs, Encoding.Default);

            //  
            gr = Group.Read(br);
            //  
            br.Close();
            fs.Close();

            gr.Print();
        }
    }
}