using System;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

namespace CSharpApplication.SearchInFiles
{
    //      ,  DOS' 
    class Search
    {
        static void Main()
        {
            Console.Write("   : ");
            string Path = Console.ReadLine();
            Console.Write("   : ");
            string Mask = Console.ReadLine();
            Console.Write("     : ");
            string Text = Console.ReadLine();

            //   (   )
            if(Path[Path.Length - 1] != '\\')
                Path += '\\';

            //      
            DirectoryInfo di = new DirectoryInfo(Path);
            //    
            if(!di.Exists)
            {
                Console.WriteLine(" !!!");
                return;
            }
            
            //      
            //   

            //  .  \.
            Mask = Mask.Replace(".", @"\." /* (".", "\\.") */);
            //  ?  .
            Mask = Mask.Replace("?", ".");
            //  *  .*
            Mask = Mask.Replace("*", ".*");
            // ,      
            Mask = "^" + Mask + "$";
            
            //    
            //   
            Regex regMask = new Regex(Mask, RegexOptions.IgnoreCase);
            
            //     
            Text = Regex.Escape(Text);
            //    
            //   
            Regex regText = new Regex(Text, RegexOptions.IgnoreCase);

            //   
            ulong Count = FindTextInFiles(di, regText, regMask);
            Console.WriteLine("  : {0}.", Count);
        }

        //  
        static ulong FindTextInFiles(DirectoryInfo di, Regex regText, Regex regMask)
        {
            //     
            StreamReader sr = null;
            //   
            MatchCollection mc = null;
            
            //   
            ulong CountOfMatchFiles = 0;

            FileInfo [] fi = null;
            try
            {
                //   
                fi = di.GetFiles();
            }
            catch
            {
                return CountOfMatchFiles;
            }
        
            //   
            foreach(FileInfo f in fi)
            {
                //    
                if(regMask.IsMatch(f.Name))
                {
                    //  
                    ++CountOfMatchFiles;
                    Console.WriteLine("File " + f.Name + ":");

                    //  
                    sr = new StreamReader(di.FullName + @"\" + f.Name,
                        Encoding.Default);  
                    //  
                    string Content = sr.ReadToEnd();
                    //  
                    sr.Close();
                    //   
                    mc = regText.Matches(Content);
                    //   
                    foreach(Match m in mc)
                    {
                        Console.WriteLine("    {0}.", m.Index);
                    }

                    /******************************************************/
                    /*  
                    /******************************************************/
                    if(mc.Count == 0)
                    {
                        Console.WriteLine("      .");
                    }
                }
            }

            /******************************************************/
            /*  
            /******************************************************/
            Console.WriteLine("     {0} {1}",
                    di.FullName, CountOfMatchFiles);
            
            //   
            DirectoryInfo [] diSub  = di.GetDirectories();
            //      ()
            //    
            foreach(DirectoryInfo diSubDir in diSub)
                CountOfMatchFiles += FindTextInFiles(diSubDir, regText, regMask);

            //    
            return CountOfMatchFiles;
        }
    }
}