using System;
using System.Drawing;
using System.Windows.Forms;

namespace CSharpApplication.MouseAndLabelAndButton
{
    // ,  ,   
    class MouseCoords : Form
    {
        //   
        Label lCoords = new Label();
        //   
        Button bCoords = new Button();

        static void Main()
        {
            //  
            Application.Run(new MouseCoords());
        }

        // 
        MouseCoords()
        {
            // 
            lCoords.Parent = this;
            //     
            lCoords.AutoSize = true;
            //  
            lCoords.BorderStyle = BorderStyle.FixedSingle;
            //      
            //        
            lCoords.MouseMove += new MouseEventHandler(lCoords_MouseMove);

            // 
            bCoords.Parent = this;
            //  
            bCoords.FlatStyle = FlatStyle.Flat;
            // 
            bCoords.Width = 100;
            //      
            //        
            bCoords.MouseMove += new MouseEventHandler(bCoords_MouseMove);

            //  
            Text = "  ...";
            //     
            WindowState = FormWindowState.Maximized;
        }

        //      
        protected override void OnMouseMove(MouseEventArgs ea)
        {
            //   
            base.OnMouseMove(ea);
            //      
            lCoords.Location = new Point(ea.X + 1, ea.Y);
            //      
            lCoords.Text = String.Format("X = {0,-5}Y = {1}", ea.X, ea.Y);
            //      
            bCoords.Location = new Point(ea.X + 1, ea.Y - bCoords.Height);
            //      
            bCoords.Text = String.Format("X = {0,-5}Y = {1}", ea.X, ea.Y);
        }

        //      
        private void lCoords_MouseMove(object sender, MouseEventArgs ea)
        {
            //      
            //      
            //  
            Point pt = PointToClient(Control.MousePosition);
            pt.X += 1;
            //  
            lCoords.Location = pt;
            //      
            lCoords.Text = String.Format("X = {0,-5}Y = {1}", 
                pt.X, pt.Y);
        }

        //      
        private void bCoords_MouseMove(object sender, MouseEventArgs e)
        {
            //      
            //      
            //  
            Point pt = PointToClient(Control.MousePosition);
            pt.X += 1;
            pt.Y -= bCoords.Height;
            //  
            bCoords.Location = pt;
            //      
            bCoords.Text = String.Format("X = {0,-5}Y = {1}", 
                pt.X, pt.Y);
        }
    }
}