using System;
using System.Drawing;
using System.Windows.Forms;
//   
using System.Resources;
// 
using System.IO;
//  
using System.Text.RegularExpressions;
// 
using System.Diagnostics;

//   ,     
namespace CSharpApplication.SearchFileByMask
{
    class Search : Form
    {
        //    
        private TextBox Path;
        //    
        private TextBox Mask;
        //       
        private Button Browse;
        //  
        private Button GoSearch;
        //       
        private CheckBox SubDir;
        //   
        private ListBox FilesList;
        //    
        private Label MaskText;
        //    
        private Label PathText;     
        //    
        private FolderBrowserDialog BrowserDialog;
        //   
        private MainMenu TopMenu;
        //  ""
        private MenuItem menuItemExit;
        //   ""
        private MenuItem menuItemOperations;
        //  "  "
        private MenuItem menuItemDelete;
        //  "    ..."
        private MenuItem menuItemMove;
        //  "   "
        private MenuItem menuItemGo;
        
        static void Main()
        {
            //  
            Application.Run(new Search());
        }

        /****************************************************************/
        /*     InitializeComponent.
         *     , ,  ,
         *      .  
         *         
         *      .
         *   , ,      Microsoft,
         *       ,
         *       - 
         *    (  HTML- 
         * Microsoft Word).    ,  
         *       .
         ***************************************************************/
        private void InitializeComponents()
        {
            //      
            ResourceManager resources = new ResourceManager(typeof(Search));
            
            /*********************************************************/
            /*   
            /*********************************************************/

            this.PathText = new Label();
            this.MaskText = new Label();
            
            this.Path = new TextBox();
            this.Mask = new TextBox();
            
            this.FilesList = new ListBox();
            
            this.Browse = new Button();
            this.GoSearch = new Button();
            
            this.SubDir = new CheckBox();

            this.BrowserDialog = new FolderBrowserDialog();
            
            this.TopMenu = new MainMenu();

            this.menuItemOperations = new MenuItem();

            this.menuItemExit = new MenuItem();
            this.menuItemDelete = new MenuItem();
            this.menuItemMove = new MenuItem();
            this.menuItemGo = new MenuItem();
            
            /*  .
             *    ,      
             *     
             *      
             *  ,   . .
            */ 
            this.SuspendLayout();
            
            //     !!!
            
            // 
            // PathText
            // 
            // 
            this.PathText.AutoSize = true;
            //  
            this.PathText.ForeColor = Color.Blue;
            // 
            this.PathText.Location = new Point(0, 5);
            // 
            this.PathText.Name = "PathText";
            //    (    )
            this.PathText.TabIndex = 0;
            // 
            this.PathText.Text = "   :";
            // 
            // MaskText
            // 
            this.MaskText.AutoSize = true;
            this.MaskText.ForeColor = Color.Blue;
            this.MaskText.Location = new Point(0, 40);
            this.MaskText.Name = "MaskText";
            this.MaskText.TabIndex = 1;
            this.MaskText.Text = "   :";
            // 
            // Path
            // 
            //       -
            //     
            //    
            this.Path.Anchor = AnchorStyles.Top | AnchorStyles.Left 
                | AnchorStyles.Right;
            this.Path.AutoSize = false;
            this.Path.Location = new Point(0, 20);
            this.Path.Name = "Path";
            this.Path.Size = new Size(269, 20);
            this.Path.TabIndex = 2;
            this.Path.Text = "";
            //    
            this.Path.TextChanged += new EventHandler(this.OnPathChanged);
            // 
            // Mask
            // 
            this.Mask.Anchor = AnchorStyles.Top | AnchorStyles.Left 
                | AnchorStyles.Right;
            this.Mask.Location = new Point(0, 55);
            this.Mask.Name = "Mask";
            this.Mask.Size = new Size(140, 20);
            this.Mask.TabIndex = 4;
            this.Mask.Text = "";
            //    
            this.Mask.KeyDown += new KeyEventHandler(this.OnMaskKeyDown);
            // 
            // FilesList
            // 
            this.FilesList.Anchor = AnchorStyles.Top | AnchorStyles.Bottom 
                | AnchorStyles.Left | AnchorStyles.Right;
            this.FilesList.Location = new Point(0, 85);
            this.FilesList.Name = "FilesList";
            //   (  Control'  Shift')
            this.FilesList.SelectionMode = SelectionMode.MultiExtended;
            this.FilesList.Size = new Size(301, 186);
            this.FilesList.TabIndex = 7;
            // 
            // Browse
            // 
            this.Browse.Anchor = AnchorStyles.Top | AnchorStyles.Right;
            this.Browse.ForeColor = Color.Blue;
            this.Browse.Location = new Point(277, 20);
            this.Browse.Name = "Browse";
            this.Browse.Size = new Size(24, 23);
            this.Browse.TabIndex = 3;
            this.Browse.Text = "...";
            //   
            this.Browse.Click += new EventHandler(this.OnBrowseClick);
            // 
            // GoSearch
            // 
            this.GoSearch.Anchor = AnchorStyles.Top | AnchorStyles.Right;
            this.GoSearch.Enabled = false;
            this.GoSearch.ForeColor = Color.Blue;
            this.GoSearch.Location = new Point(235, 55);
            this.GoSearch.Name = "GoSearch";
            this.GoSearch.Size = new Size(65, 23);
            this.GoSearch.TabIndex = 6;
            this.GoSearch.Text = "";
            //   
            this.GoSearch.Click += new EventHandler(this.OnSearchClick);
            // 
            // SubDir
            //
            this.SubDir.Anchor = AnchorStyles.Top | AnchorStyles.Right;
            this.SubDir.ForeColor = Color.Blue;
            this.SubDir.Location = new Point(143, 50);
            this.SubDir.Name = "SubDir";
            this.SubDir.Size = new Size(95, 28);
            this.SubDir.TabIndex = 5;
            this.SubDir.Text = " \n";
            // 
            // BrowserDialog
            // 
            //      
            this.BrowserDialog.Description = "   ";
            //  "  " 
            this.BrowserDialog.ShowNewFolderButton = false;
            // 
            // TopMenu
            // 
            //    
            this.TopMenu.MenuItems.AddRange(new MenuItem[] 
                                            {
                                                this.menuItemExit,
                                                this.menuItemOperations
                                            }
                                           );
            // 
            // menuItemExit
            // 
            //       
            this.menuItemExit.Index = 0;
            //   
            this.menuItemExit.Shortcut = Shortcut.CtrlX;
            // 
            this.menuItemExit.Text = "&";
            //    
            this.menuItemExit.Click += new EventHandler(this.OnMenuExitClick);
            // 
            // menuItemOperations
            // 
            this.menuItemOperations.Index = 1;
            this.menuItemOperations.MenuItems.AddRange(new MenuItem[] 
                                                       {
                                                           this.menuItemDelete,
                                                           this.menuItemMove,
                                                           this.menuItemGo
                                                       }
                                                      );            
            this.menuItemOperations.Text = "&";
            // ,     
            this.menuItemOperations.Popup += new EventHandler(this.OnMenuPopup);
            // 
            // menuItemDelete
            // 
            this.menuItemDelete.Index = 0;
            this.menuItemDelete.Text = "  ";
            this.menuItemDelete.Click += new EventHandler(menuItemDelete_Click);
            // 
            // menuItemMove
            // 
            this.menuItemMove.Index = 1;
            this.menuItemMove.Text = "    ...";
            this.menuItemMove.Click += new EventHandler(menuItemMove_Click);
            // 
            // menuItemGo
            // 
            this.menuItemGo.Index = 2;
            this.menuItemGo.Text = "   ";
            this.menuItemGo.Click += new EventHandler(menuItemGo_Click);
            
            //       .
            //    ,   ,   
            //  - ,   - .
            //       .
            this.FilesList.ContextMenu = 
                new ContextMenu(new MenuItem[] 
                                {
                                    this.menuItemDelete.CloneMenu(),
                                    this.menuItemMove.CloneMenu(),
                                    this.menuItemGo.CloneMenu()
                                }
                               );
 
            //      .
            //        .
            this.FilesList.ContextMenu.Popup += new EventHandler(this.OnMenuPopup);
            //     
            this.FilesList.DoubleClick += new EventHandler(FilesList_DoubleClick);
            
            // 
            // Search
            // 
            this.AutoScaleBaseSize = new Size(5, 13);
            this.BackColor = SystemColors.Control;
            this.ClientSize = new Size(302, 273);

            //       
            // (   )
            this.Controls.AddRange(new Control[] 
                                  {
                                      this.GoSearch,
                                      this.MaskText,
                                      this.Browse,
                                      this.FilesList,
                                      this.Mask,
                                      this.SubDir,
                                      this.Path,
                                      this.PathText}
                                  );
            //        
            this.Icon = ((Icon)(resources.GetObject("$this.Icon")));
            //  
            this.Menu = this.TopMenu;
            //      
            this.MinimumSize = new Size(300, 300);
            this.Name = "Search";
            //     
            this.StartPosition = FormStartPosition.CenterScreen;
            this.Text = " ";

            //   
            this.ResumeLayout(false);
        }

        Search()
        {
            //       
            InitializeComponents();
        }

        //       
        private void StartSearch()
        {
            //    
            if(!Directory.Exists(Path.Text))
            {
                //  
                MessageBox.Show(" " + Path.Text + "   ",
                    "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //   (  )
            if(Path.Text[Path.Text.Length - 1] != '\\')
                Path.Text += '\\';

            //    
            if(Mask.Text.Length == 0)
            {
                //   
                Mask.Text = "*.*";
            }

            //      
            Path.Text = Path.Text.TrimEnd();
            
            //      
            //   

            //  .  \.
            string RegMask = Mask.Text.Replace(".", @"\.");
            //  ?  .
            RegMask = RegMask.Replace("?", ".");
            //  *  .*
            RegMask = RegMask.Replace("*", ".*");
            // ,      
            RegMask = "^" + RegMask + "$";

            //    
            //   
            Regex RegExpr = new Regex(RegMask, RegexOptions.IgnoreCase);

            string PathToDirectory = Path.Text;

            //   
            FilesList.Items.Clear();

            //   
            uint Count = FillListOfFiles(PathToDirectory, RegExpr);

            MessageBox.Show("    \n" + Path.Text + 
                " , \n  ,  " + Count,
                " ", MessageBoxButtons.OK,
                MessageBoxIcon.Information);
        }

        // ,      
        private uint FillListOfFiles(string dir, Regex mask)
        {
            //   
            uint Count = 0;

            string [] names;
            try
            {
                //    
                // (      :-( )
                names = Directory.GetFiles(dir);
            }
            catch
            {
                // 
                return Count;
            }

            //   
            foreach(string name in names)
            {
                //     ?!!
                if(mask.IsMatch(name))
                {
                    //    
                    FilesList.Items.Add(name);
                    ++Count;
                }
            }

            //     ( )
            if(this.SubDir.Checked)
            {
                //      
                string [] dirnames = Directory.GetDirectories(dir);
                //   
                foreach(string dirname in dirnames)
                {
                    //    
                    Count += FillListOfFiles(dirname, mask);
                }
            }

            //    
            return Count;
        }
        //      
        private void OnPathChanged(object sender, EventArgs e)
        {
            //   
            Path.Text = Path.Text.TrimStart();
            //  ?
            if(Path.Text.Length == 0)
            {
                //  !
                GoSearch.Enabled = false;
            }
            else
            {
                //  !!!
                GoSearch.Enabled = true;
            }
        }

        //     
        private void OnBrowseClick(object sender, EventArgs e)
        {
            //     
            if(Directory.Exists(Path.Text))
            {
                //   ( )
                if(Path.Text[Path.Text.Length - 1] != '\\')
                    Path.Text += '\\';
                //        
                BrowserDialog.SelectedPath = Path.Text;
            }

            //  "  "   
            BrowserDialog.ShowNewFolderButton = false;
            //      
            if(BrowserDialog.ShowDialog() == DialogResult.OK)
            {
                //  user ,    -  
                Path.Text = BrowserDialog.SelectedPath;
            }        
        }

        //   ""
        private void OnSearchClick(object sender, EventArgs e)
        {
            StartSearch();
        }
        //        
        private void OnMaskKeyDown(object sender, KeyEventArgs e)
        {
            //   Enter   "" 
            if(e.KeyCode == Keys.Enter && GoSearch.Enabled == true)
            {
                //  
                StartSearch();
            }
        }
        //   ""
        private void OnMenuExitClick(object sender, EventArgs e)
        {
            // 
            Close();
        }
        //   
        private void OnMenuPopup(object sender, EventArgs e)
        {
            //    
            Menu menu = (Menu)sender;
            //      
            if(FilesList.SelectedItems.Count == 0)
            {           
                //   
                foreach(MenuItem mi in menu.MenuItems)
                {
                    mi.Enabled = false;
                }
            }
            else
            {
                //   
                foreach(MenuItem mi in menu.MenuItems)
                {
                    mi.Enabled = true;
                }
            }
        }
        //    
        private void menuItemDelete_Click(object sender, EventArgs e)
        {
            // 
            DialogResult Yes = MessageBox.Show(" ?", " ",
                MessageBoxButtons.YesNo, MessageBoxIcon.Question);

            //    
            if(Yes == DialogResult.Yes)
            {
                //  ""
                int Count = FilesList.SelectedIndices.Count;
                for(int i = Count - 1; i >= 0; i--)
                {
                    //  
                    File.Delete((string)FilesList.SelectedItems[i]);
                    //    
                    FilesList.Items.RemoveAt(FilesList.SelectedIndices[i]);
                }
            }
        }
        //     ,  
        private void menuItemMove_Click(object sender, EventArgs e)
        {
            //       (   )
            BrowserDialog.ShowNewFolderButton = true;
            string dir;
            //  
            if(BrowserDialog.ShowDialog() == DialogResult.OK)
            {
                //   
                dir = BrowserDialog.SelectedPath;
            }
            else
                //   -  
                return;
            
            //  ""
            int Count = FilesList.SelectedIndices.Count;
            string name, path;
            for(int i = Count - 1; i >= 0; i--)
            {
                //      
                path = (string)FilesList.SelectedItems[i];
                //   
                name = path.Substring(path.LastIndexOf('\\'));
                //      
                File.Move(path, dir + name);
                //      
                FilesList.Items.RemoveAt(FilesList.SelectedIndices[i]);
            }
        }

        //        
        private void menuItemGo_Click(object sender, EventArgs e)
        {
            //  ,    
            int Count = FilesList.SelectedIndices.Count;
            string oldpath = "", newpath;
            for(int i = 0; i < Count; i++)
            {
                //    
                newpath = (string)FilesList.SelectedItems[i];
                //   
                newpath = newpath.Substring(0, newpath.LastIndexOf('\\'));
                //        
                if(newpath == oldpath)
                    continue;
                //     
                Process.Start("explorer.exe", newpath);
                //      
                oldpath = newpath;
            }
        }

        //    
        private void FilesList_DoubleClick(object sender, EventArgs e)
        {
            //   ""
            if(FilesList.SelectedIndices.Count == 0)
                return;
            // 
            Process.Start((string)FilesList.SelectedItem);
        }
    }
}