using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
namespace PictureBrowser
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class PictureBrowserForm : System.Windows.Forms.Form
	{
		//     	
		private System.Windows.Forms.PictureBox image;
		//     
		private System.Windows.Forms.Label info;
		//   	
		private System.Windows.Forms.TreeView catalogs;
		//     
		private System.Windows.Forms.Label info2;
		private System.ComponentModel.IContainer components;

		public PictureBrowserForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//   (   )	
			PrepareTree();
			//     	
			FillByDrives();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.image = new System.Windows.Forms.PictureBox();
			this.info = new System.Windows.Forms.Label();
			this.catalogs = new System.Windows.Forms.TreeView();
			this.info2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// image
			// 
			this.image.Location = new System.Drawing.Point(328, 48);
			this.image.Name = "image";
			this.image.Size = new System.Drawing.Size(320, 288);
			this.image.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.image.TabIndex = 0;
			this.image.TabStop = false;
			// 
			// info
			// 
			this.info.Location = new System.Drawing.Point(328, 8);
			this.info.Name = "info";
			this.info.TabIndex = 1;
			this.info.Text = "";
			// 
			// catalogs
			// 
			this.catalogs.ImageIndex = -1;
			this.catalogs.Location = new System.Drawing.Point(0, 48);
			this.catalogs.Name = "catalogs";
			this.catalogs.SelectedImageIndex = -1;
			this.catalogs.Size = new System.Drawing.Size(320, 288);
			this.catalogs.TabIndex = 2;
			this.catalogs.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.catalogs_AfterSelect);
			this.catalogs.BeforeExpand += new System.Windows.Forms.TreeViewCancelEventHandler(this.catalogs_BeforeExpand);
			// 
			// info2
			// 
			this.info2.Location = new System.Drawing.Point(8, 8);
			this.info2.Name = "info2";
			this.info2.TabIndex = 3;
			this.info2.Text = " ";
			// 
			// PictureBrowserForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(656, 349);
			this.Controls.Add(this.info2);
			this.Controls.Add(this.catalogs);
			this.Controls.Add(this.info);
			this.Controls.Add(this.image);
			this.Name = "PictureBrowserForm";
			this.Text = "PictureBrowser";
			
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		
		static void Main() 
		{
			Application.Run(new PictureBrowserForm());
		}

		/// <summary>
		///       
		/// </summary>
		//     	
		private void PrepareTree()
		{
			try
			{
				//   
				imglist = new ImageList();
				//     
				imglist.Images.Add(new Icon(GetType(),"CLSDFOLD.ICO"));
				imglist.Images.Add(new Icon(GetType(),"OPENFOLD.ICO"));
				imglist.Images.Add(new Icon(GetType(),"NOTE11.ICO"));				
				imglist.Images.Add(new Icon(GetType(),"NOTE12.ICO"));
				imglist.Images.Add(new Icon(GetType(),"Drive01.ico"));
				catalogs.ImageList = imglist ; 
				//    ( ),   						//      	 
				bitmap = new Bitmap(GetType(),"nopicture.bmp");			
			}
			catch(Exception  ex)
			{
				MessageBox.Show(ex.Message,"     ",MessageBoxButtons.OK,MessageBoxIcon.Error);
				Application.Exit();
			}
		}
		//    	
		private ImageList imglist;
		//    
		private Bitmap bitmap;
		private void FillByDrives()
		{	
			//      
			string []drives = Directory.GetLogicalDrives();
			//   	
			foreach(string drive in drives)
			{
				//      
				TreeNode node = new TreeNode(drive,4,4);
				//     	
				catalogs.Nodes.Add(node);
				//    
				FillByDirectories(node);
			}
		}
		//       	
		private void FillByDirectories(TreeNode node)
		{
			try
			{
				//  node.FullPath -     
				DirectoryInfo dirinfo = new DirectoryInfo(node.FullPath);
				//    
				DirectoryInfo[] dirs = dirinfo.GetDirectories();
				//  
				foreach(DirectoryInfo dir in dirs)
				{
					TreeNode tree = new TreeNode(dir.Name,0,1);
					//   Dir,     
					// 
					tree.Tag = "Dir";
					node.Nodes.Add(tree);
				}
				//    
				FileInfo[] files = dirinfo.GetFiles();
				//  
				foreach(FileInfo file in files)
				{
					TreeNode tree = new TreeNode(file.Name,2,3);
					//   File,     
					// 
					tree.Tag = "File";
					node.Nodes.Add(tree);
				}
			}
			//       ,   
			// 	
			catch 
			{
			}
			
		}

		private void catalogs_BeforeExpand(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			//      
			catalogs.BeginUpdate();
			try
			{
				foreach(TreeNode node in e.Node.Nodes)
				{
					if(node.Tag == "Dir")
						FillByDirectories(node);
				}

			}
			catch
			{

			}
			//      
			catalogs.EndUpdate();
			
		}
		// ,    	
		private void catalogs_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			if(e.Node.Tag=="File")
			{
				try
				{
					//   	
					image.Image = Image.FromFile(e.Node.FullPath);
				}
				catch
				{
					//   
					image.Image = bitmap; 
				}
			}

		}

	}
}
